// Copyright (C) 2007 Anders Logg.
// Licensed under the GNU LGPL Version 2.1.
//
// First added:  2007-04-02
// Last changed: 2007-04-05

#ifndef __FORM_H
#define __FORM_H

#include <ufc.h>

#include <dolfin/Array.h>
#include <dolfin/Function.h>

namespace dolfin
{

  /// Base class for UFC code generated by FFC for DOLFIN with option -l

  class Form
  {
  public:

    /// Destructor
    virtual ~Form() {}

    /// Return UFC form
    virtual const ufc::form& form() const = 0;

    /// Return array of coefficients
    virtual const Array<Function*>& coefficients() const = 0;

  };

}

#endif
